/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/dozer/DozerMapperTransformer.java#1 $
 * 
 * Copyright (c) 2009 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.common.dozer;

import org.dozer.Mapper;

import com.netapp.common.util.Transformer;

/**
 * A {@link Transformer} implementation that maps objects using 
 * <a href="http://dozer.sourceforge.net">Dozer</a>.
 * 
 * Helpful for using Dozer in tandem with the utility methods in {@link com.netapp.common.util.CollectionUtils}.
 * 
 * @see com.netapp.common.util.CollectionUtils
 * @author sirianni
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class DozerMapperTransformer<S, T> implements Transformer<S, T> {

    private Mapper mapper;
    private Class<T> destClass;

    public DozerMapperTransformer(Class<T> destClass, Mapper mapper) {
        this.mapper = mapper;
        this.destClass = destClass;
    }
    
    public T transform(S object) {
        return this.mapper.map(object, this.destClass);
    }
    
}