/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/FailureStrategy.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow;

/**
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public enum FailureStrategy {
    /** Fail immediately */
    IMMEDIATE,
    /** Defer failure to the next checkpoint */
    CHECKPOINT,
    /** Defer failure to the end of the workflow list */
    END,
    /** Ignore the failure, just log a warning */
    IGNORE;
    
    public static FailureStrategy max(FailureStrategy... strategies) {
        FailureStrategy result = null;
        for (FailureStrategy s : strategies) {
            if (result == null || s.ordinal() < result.ordinal()) {
                result = s;
            }
        }
        return result;
    }

}
