/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/gwt/codegen/GWTEnumConverter.java#1 $
 * 
 * Copyright (c) 2009 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.common.gwt.codegen;

import javax.lang.model.element.TypeElement;
import javax.lang.model.element.VariableElement;
import javax.lang.model.util.ElementFilter;
import javax.lang.model.util.Elements;
import javax.lang.model.util.Types;

import com.netapp.common.generator.NetappClassGenerator;

public class GWTEnumConverter extends NetappClassGenerator {

    private TypeElement typeElement;
    private Elements elements;
    private Types types;

    GWTEnumConverter(TypeElement typeElement, Elements elements, Types types) {
        super(elements.getPackageOf(typeElement).getQualifiedName().toString());
        
        this.typeElement = typeElement;
        this.elements = elements;
        this.types = types;
        
        generateClassFile();
    }
    
    private void generateClassFile() {
        addLine("public enum %s {", this.typeElement.getSimpleName());
        
        increaseIndent();
        
        for (VariableElement field : ElementFilter.fieldsIn(this.typeElement.getEnclosedElements())) {
            addLine("%s,", field.getSimpleName());
        }
        addLine(";");
        
        decreaseIndent();
        
        addLine("}");
    }
    
}