/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/logging/LogAdapter.java#1 $
 * 
 * Copyright (c) 2008 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.common.logging;

/**
 * Provide a logger-implementation independent interface
 * under {@link NALogger}.
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public interface LogAdapter {
    /**
     * Log a localized LogMessage
     * @param msg
     */
    void log(LogMessage msg);
    
    
    /**
     * Log a localized LogMessage and associated throwable
     * @param msg
     * @param t
     */
    void log(LogMessage msg, Throwable t);
    
    /**
     * Log an unlocalized log message
     * @param level LogLevel of this message
     * @param msg Message to log
     */
    void log(LogLevel level, String msg);
    
    /**
     * Log an unlocalized log message and associated throwable
     * @param level
     * @param msg
     * @param t
     */
    void log(LogLevel level, String msg, Throwable t);
}
