/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/platform/linux/RedhatRawDevicesFile.java#1 $
 * 
 * Copyright (c) 2006 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.platform.linux;

import java.io.File;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.netapp.common.platform.RawDeviceMapping;

public class RedhatRawDevicesFile extends RawDevicesFile {

    private static final File REDHAT_RAW_DEVICES_FILE = new File("/etc/sysconfig/rawdevices");
    
    /**
     * Matches "/dev/raw/raw5 /dev/sdb1" and creates a group for the raw device and disk 
     */
    private static final Pattern RAW_DEVICE_ENTRY_PATTERN = Pattern.compile("\\s*(/dev/raw/raw\\d+)\\s+(\\S+).*");
    
    @Override
    protected RawDeviceMapping mappingFromEntry(String entry) {
        Matcher matcher = RAW_DEVICE_ENTRY_PATTERN.matcher(entry);
        if (matcher.matches()) {
            return new RawDeviceMapping(new File(matcher.group(1)), new File(matcher.group(2)));
        }
        else {
            return null;
        }
    }

    @Override
    protected String mappingToEntry(RawDeviceMapping mapping) {
        return String.format("%s %s", mapping.getRawDevice(), mapping.getDisk());
    }
    
    @Override
    protected File getFile() {
        return REDHAT_RAW_DEVICES_FILE;
    }
}
