/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/generator/autozapi/AutoZapiTypedefGenerator.java#1 $
 * 
 * Copyright (c) 2009 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.generator.autozapi;

import com.netapp.common.zapi.parser.Typedef;

public class AutoZapiTypedefGenerator extends AutoZapiTypeGenerator<Typedef> {

    public AutoZapiTypedefGenerator(AutoZapiGeneratorFactory generatorFactory, Typedef typedef) {
        super(generatorFactory, typedef);
    }
    
    /**
     * Return the java type name for this type.
     * If this typedef is a declared struct, the returned type is the zapi name converted to Java.
     * If this typedef is an alias, the returned type is the Java name of the aliased-to type
     * @return
     */
    @Override
    public String getQualifiedName() {
        Typedef typedef = getTarget();
        
        String javaType = null;
        if (typedef.isAlias()) {
            javaType = AutoZapiFieldGenerator.SIMPLE_TYPE_MAP.get(typedef.getRootType().getName());
        }
        else {
            javaType = super.getQualifiedName();
        }
        return javaType;
    }
    
}
